﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace API_Application_4
{
    public partial class Form1 : Form
    {
        [DllImport("user32.dll")]
        static extern bool ClientToScreen(IntPtr hwnd, ref Point lpPoint);

        [DllImport("user32.dll")]
        static extern bool ClipCursor(ref RECT lpRect);

        public struct RECT
        {
            public int Left;
            public int Top;
            public int Right;
            public int Bottom;

            public RECT(int left, int top, int right, int bottom)
            {
                Left = left;
                Top = top;
                Right = right;
                Bottom = bottom;
            }
        }

        [DllImport("user32.dll")]
        static extern bool GetCursorPos(out POINT lpPoint);

        [DllImport("user32.dll")]
        static extern bool SetCursorPos(int X, int Y);

        [DllImport("user32.dll")]
        static extern bool GetClipCursor(out RECT lpRect);

        [StructLayout(LayoutKind.Sequential)]
        public struct POINT
        {
            public int X;
            public int Y;

            public POINT(int x, int y)
            {
                this.X = x;
                this.Y = y;
            }
        }

        [DllImport("user32.dll")]
        static extern bool SwapMouseButton(bool fSwap);

        [DllImport("user32.dll")]
        static extern uint GetDoubleClickTime();

        [DllImport("user32.dll")]
        static extern int ShowCursor(bool bShow);

        public Form1()
        {
            InitializeComponent();
        }


        public void MoveCursorOverButton(Button button)
        {
            IntPtr handle = IntPtr.Zero;
            Point point;
            int x = 0;
            int y = 0;
            int width = 0;
            int height = 0;
            bool coordinatesFound = false;

            if (button != null)
            {
                width = button.Size.Width;
                height = button.Size.Height;
                handle = button.Handle;
            }

            if ((width > 0) && (height > 0))
            {
                point = new Point();
                x = (width / 2);
                y = (height / 2);

                coordinatesFound = ClientToScreen(handle, ref point);

                if (coordinatesFound == true)
                {
                    SetCursorPos(point.X + x, point.Y + y);
                }
            }
        }

        private void button1_MouseEnter(object sender, EventArgs e)
        {
            MoveCursorOverButton((Button)sender);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            RECT rect = new RECT();
            rect.Left = Convert.ToInt16(textBox1.Text);
            rect.Right = Convert.ToInt16(textBox3.Text);
            rect.Top = Convert.ToInt16(textBox2.Text);
            rect.Bottom = Convert.ToInt16(textBox4.Text);

            ClipCursor(ref rect);
        }

        private void Form1_MouseMove(object sender, MouseEventArgs e)
        {
            POINT po = new POINT();

            if (GetCursorPos(out po))
            {
                label5.Text = "Cursor position: "+ Convert.ToString(po.X) + ";" + Convert.ToString(po.Y);
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            RECT rect = new RECT();

            GetClipCursor(out rect);

            textBox1.Text = Convert.ToString(rect.Left);
            textBox2.Text = Convert.ToString(rect.Top);
            textBox3.Text = Convert.ToString(rect.Right);
            textBox4.Text = Convert.ToString(rect.Bottom);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            SwapMouseButton(true);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            SwapMouseButton(false);
        }

        private void button6_Click(object sender, EventArgs e)
        {
            label6.Text = Convert.ToString(GetDoubleClickTime());
        }

        private void button7_Click(object sender, EventArgs e)
        {
            ShowCursor(true);
        }

        private void button8_Click(object sender, EventArgs e)
        {
            ShowCursor(false);
        }


    }
}
